﻿Shader "mViz/Line"
{
  Properties
  {
    _MainTex("Texture", 2D) = "white" {}
    _Color("Color", Color) = (1,0,0,1)
    _TimeF("Time", Range(0.0, 1.0)) = 0.5
    _Pow("pow", float) = 100
  }
    SubShader
  {
    Blend One One
    Tags { "RenderType" = "Opaque" }
    LOD 100
    Pass
    {
      CGPROGRAM
      #pragma vertex vert
      #pragma fragment frag
      // make fog work
      #pragma multi_compile_fog

      #include "UnityCG.cginc"
      struct appdata
      {
        float4 vertex : POSITION;
        float4 color : COLOR;
        float2 uv : TEXCOORD0;
      };
      struct v2f
      {
        float2 uv : TEXCOORD0;
        float4 color : COLOR;
        UNITY_FOG_COORDS(1)
        float4 vertex : SV_POSITION;
      };
      sampler2D _MainTex;
      float4 _MainTex_ST;
      float4 _Color;
      float _TimeF;
      float _Pow;
        
      v2f vert(appdata v)
      {
        v2f o;
        o.vertex = UnityObjectToClipPos(v.vertex);
        o.vertex.z = 0; //HACK: Make lines stick to ground without weird artifacts.
        o.uv = TRANSFORM_TEX(v.uv, _MainTex);
        o.color = v.color;
        UNITY_TRANSFER_FOG(o,o.vertex);
        return o;
      }

      float f(float x, float s) {
        return (1.0 - ((x * s)) * ((x * s)));
      }

      float mod(float v, float m) {
        return v % m;
      }

      //https://www.desmos.com/calculator/r8ig1fswdr
      float magicFormula(float x, float f, float t) {
        return (1.0 - pow(mod((x - 1.0) * f, 2) - 1, 2.0));
      }

      float pos(float x) {
        return x < 0 ? 0 : x;
      }

      float f2(float x) {
        return pow(abs(x - 1), 14);
      }

      fixed4 frag(v2f i) : SV_Target
      {
        // sample the texture
        //fixed4 col = tex2D(_MainTex, i.uv);
        float t = _TimeF;
        float x = i.color.r;
        
        float4 col = _Color * (pow(1 - abs(x - t), _Pow));

        //TEST
        //col = _Color * x;

        // apply fog
        UNITY_APPLY_FOG(i.fogCoord, col);
        return col;
      }
      ENDCG
    }
  }
}